/*
** ObjectiveAmiga: Interface to class RexxHost
** See GNU:lib/libobjam/ReadMe for details
*/


#include <exec/ports.h>
#include <exec/types.h>
#include <dos/rdargs.h>
#include <rexx/errors.h>

#import <objc/Object.h>


@interface RexxHost: Object
{
  @private
  struct RexxMsg *currentMsg;
  char *currentArgs;
  char *hostName;
  char *extensionName;
  struct MsgPort *msgPort;
  ULONG sigMask;
  BOOL doQuit;
  BOOL openedRexxSysBase;
  LONG messagesSent;
  BOOL refused;
  struct RDArgs *rdArgs;
  BOOL freeArgs;
  BOOL argsFailed;
  char *tmpArgs;
}

// Create and delete instances

- initHost:(char *)newHost suffix:(char *)newExtension;
- initHost:(char *)newHost;
+ newHost:(char *)newHost suffix:(char *)newExtension;
+ newHost:(char *)newHost;
- free;

// Control methods

- run;
- quit;
- (ULONG)sigMask;
- handleRexxMsg;
- sendRexxCmd:(char *)cmd;
- (struct RexxMsg *)sendRexxMsg:(char *)s msg:(struct RexxMsg *)m flags:(LONG)flags;

// ARexx command support methods

- replyRexxCmd:(char *)s rc:(LONG)rc;
- refuseRexxCmd;
- readArgs:(LONG *)args tpl:(char *)template;

// Default ARexx commands

- (void)rxcQUIT;

@end
